
/**
 * Oberklasse für alle Hindernisse
 * Regelt die Größe und die Positionierung
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Hindernis extends Figur
{
    /** Das Rahmenobjekt des Spiels */
    protected Rahmen rahmen;
    
    /**
     * Der Konstruktor legt die Position fest
     * @param x x-Koordinate des Hindernisses
     * @param y y-Koordinate des Hindernisses
     * @param rahmen das Rahmenobjekt des Spiels
     */
    Hindernis(int x, int y, Rahmen rahmen)
    {
        super();
        PositionSetzen(x * rahmen.basisGröße + rahmen.basisGröße / 2, y * rahmen.basisGröße + rahmen.basisGröße / 2);
        this.rahmen = rahmen;
    }
    
    /**
     * Das Hindernis kann auf des Monster reagieren
     * @param monster das Monster
     */
    void Reagieren(Monster monster)
    {
        //Hier passiert nichts.
    }
}
