
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 * Beschreibt die vollständige Anzeige des Spiels
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Anzeige
{
    /** Fenster und Oberflächenelemente */
    private JFrame f;
    private JPanel hauptPanel;
    private Landkarte mapping;
    private DefaultListModel schatzListenModel;
    private JList schatzListe;
    private JScrollPane schatzListeScroll;
    private JLabel stärkeText;
    private JLabel handwaffenText;
    private JLabel kampfMonster;
    private JTextArea infoText;
    private JLabel schlüsselAnzahl;
    private JLabel schutzwaffenText;
    private DefaultListModel raumListenModel;
    private JList raumListe;
    private JScrollPane raumListeScroll;
    private JLabel schatzText;
    private JLabel raumText;
    private JLabel gesamtGewicht;
    private JPanel kampfItems;
    private JPanel raumItems;
    private JPanel endeMeldung;
    private JLabel japadapadu;
    private JLabel gefunden;
    private JButton handwaffeWeglegen;
    private JButton schutzwaffeWeglegen;
    private JButton beenden;
    private JButton spielregel;
    private JButton mitnehmen;
    private JButton dalassen;
    private JButton aktivieren;
    private JButton abbrechen;
    private JButton weiterkämpfen;
    private JButton okKnopf;
    private SpielregelAnzeige spielregelAnzeige;
    
    /** der Kontroller für die Anzeige */
    private Kontroller kontroller;

    /**
     * Speicher den Kontroller und legt die Elemente an.
     * @param k der kontroller für die Verbindung zur Programmlogik
     */
    Anzeige(Kontroller k)
    {
        kontroller = k;
        KomponentenAnlegen();
        spielregelAnzeige = new SpielregelAnzeige();
    }

    /**
     * Legt die Komponenten der Oberfläche an
     */
    private void KomponentenAnlegen()
    {
        hauptPanel = new JPanel();
        mapping = new Landkarte(kontroller);
        schatzListenModel = new DefaultListModel();
        schatzListe = new JList(schatzListenModel);
        schatzListeScroll = new JScrollPane(schatzListe);
        stärkeText = new JLabel();
        handwaffenText = new JLabel();
        kampfMonster = new JLabel();
        infoText = new JTextArea();
        schlüsselAnzahl = new JLabel();
        schutzwaffenText = new JLabel();
        raumListenModel = new DefaultListModel();
        raumListe = new JList(raumListenModel);
        raumListeScroll = new JScrollPane(raumListe);
        schatzText = new JLabel();
        raumText = new JLabel();
        gesamtGewicht = new JLabel();
        kampfItems = new JPanel();
        raumItems = new JPanel();
        endeMeldung = new JPanel();
        japadapadu = new JLabel();
        gefunden = new JLabel();
        
        mapping.setLocation(10, 10);
        mapping.setVisible(true);
        mapping.setSize(570, 330);

        schatzListeScroll.setLocation(610, 200);
        schatzListeScroll.setVisible(true);
        schatzListeScroll.setSize(180, 140);

        stärkeText.setText("Stärke: 0");
        stärkeText.setLocation(420, 350);
        stärkeText.setVisible(true);
        stärkeText.setSize(100, 20);

        handwaffenText.setText("Handwaffe: keine");
        handwaffenText.setLocation(420, 380);
        handwaffenText.setVisible(true);
        handwaffenText.setSize(160, 20);

        kampfMonster.setText("Sie kämpfen mit Monster:");
        kampfMonster.setLocation(20, 30);
        kampfMonster.setVisible(true);
        kampfMonster.setSize(250, 20);

        infoText.setEnabled(true);
        infoText.setLocation(20, 350);
        infoText.setVisible(true);
        infoText.setSize(380, 140);
        infoText.setEditable(false);

        schlüsselAnzahl.setText("Schlüssel: 0");
        schlüsselAnzahl.setLocation(420, 440);
        schlüsselAnzahl.setVisible(true);
        schlüsselAnzahl.setSize(100, 20);

        schutzwaffenText.setText("Schutzwaffe: keine");
        schutzwaffenText.setLocation(420, 410);
        schutzwaffenText.setVisible(true);
        schutzwaffenText.setSize(160, 20);

        raumListeScroll.setLocation(10, 35);
        raumListeScroll.setVisible(true);
        raumListeScroll.setSize(180, 110);

        schatzText.setText("Spielerschätze");
        schatzText.setLocation(610, 180);
        schatzText.setHorizontalAlignment(SwingConstants.CENTER);
        schatzText.setVisible(true);
        schatzText.setSize(180, 20);

        raumText.setText("Schätze im Raum");
        raumText.setLocation(10, 15);
        raumText.setHorizontalAlignment(SwingConstants.CENTER);
        raumText.setVisible(true);
        raumText.setSize(180, 20);

        gesamtGewicht.setText("Gesamtgewicht: 0");
        gesamtGewicht.setLocation(420, 470);
        gesamtGewicht.setVisible(true);
        gesamtGewicht.setSize(170, 20);

        kampfItems.setLocation(10, 10);
        kampfItems.setVisible(false);
        kampfItems.setSize(570, 330);

        raumItems.setLocation(600, 0);
        raumItems.setVisible(true);
        raumItems.setSize(200, 180);
        
        handwaffeWeglegen = new JButton("Handwaffe weglegen");
        handwaffeWeglegen.setLocation(600, 370);
        handwaffeWeglegen.setVisible(true);
        handwaffeWeglegen.setSize(190, 30);
        handwaffeWeglegen.setEnabled(false);
        handwaffeWeglegen.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                kontroller.KommandoEintragen(Kommandos.handwaffeWeglegen, 0);
            }
        });
        
        schutzwaffeWeglegen = new JButton("Schutzwaffe weglegen");
        schutzwaffeWeglegen.setLocation(600, 400);
        schutzwaffeWeglegen.setVisible(true);
        schutzwaffeWeglegen.setSize(190, 30);
        schutzwaffeWeglegen.setEnabled(false);
        schutzwaffeWeglegen.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                kontroller.KommandoEintragen(Kommandos.schutzwaffeWeglegen, 0);
            }
        });
        
        spielregel = new JButton("Spielregel");
        spielregel.setLocation(600, 430);
        spielregel.setVisible(true);
        spielregel.setSize(190, 30);
        spielregel.setEnabled(true);
        spielregel.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                spielregelAnzeige.SpielregelAnzeigen();
            }
        });
        
        beenden = new JButton("Beenden");
        beenden.setLocation(600, 460);
        beenden.setVisible(true);
        beenden.setSize(190, 30);
        beenden.setEnabled(true);
        beenden.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                kontroller.KommandoEintragen(Kommandos.spielAbbrechen, 0);
            }
        });
        
        mitnehmen = new JButton("Mitnehmen");
        mitnehmen.setLocation(5, 145);
        mitnehmen.setVisible(true);
        mitnehmen.setSize(190, 30);
        mitnehmen.setEnabled(true);
        mitnehmen.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                int index = raumListe.getSelectedIndex();
                if (index != -1)
                {
                    kontroller.KommandoEintragen(Kommandos.schatzMitnehmen, index);
                }
            }
        });
        
        aktivieren = new JButton("Aktivieren");
        aktivieren.setLocation(605, 340);
        aktivieren.setVisible(true);
        aktivieren.setSize(90, 30);
        aktivieren.setEnabled(true);
        aktivieren.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                int index = schatzListe.getSelectedIndex();
                if (index != -1)
                {
                    kontroller.KommandoEintragen(Kommandos.schatzAktivieren, index);
                }
            }
        });
        
        dalassen = new JButton("Dalassen");
        dalassen.setLocation(705, 340);
        dalassen.setVisible(true);
        dalassen.setSize(90, 30);
        dalassen.setEnabled(true);
        dalassen.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                int index = schatzListe.getSelectedIndex();
                if (index != -1)
                {
                    kontroller.KommandoEintragen(Kommandos.schatzDalassen, index);
                }
            }
        });
        
        weiterkämpfen = new JButton("Weiter kämpfen");
        weiterkämpfen.setLocation(20, 60);
        weiterkämpfen.setVisible(true);
        weiterkämpfen.setSize(150, 30);
        weiterkämpfen.setEnabled(true);
        weiterkämpfen.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                kontroller.KommandoEintragen(Kommandos.weiterKämpfen, 0);
            }
        });
        
        abbrechen = new JButton("Kampf abbrechen");
        abbrechen.setLocation(200, 60);
        abbrechen.setVisible(true);
        abbrechen.setSize(150, 30);
        abbrechen.setEnabled(true);
        abbrechen.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                kontroller.KommandoEintragen(Kommandos.kampfAbbrechen, 0);
            }
        });
        
        hauptPanel.setLocation(0, 0);
        hauptPanel.setLayout(null);
        hauptPanel.setSize(800, 500);
        hauptPanel.add(mapping);
        hauptPanel.add(schatzListeScroll);
        hauptPanel.add(stärkeText);
        hauptPanel.add(handwaffenText);
        hauptPanel.add(infoText);
        hauptPanel.add(schlüsselAnzahl);
        hauptPanel.add(schutzwaffenText);
        hauptPanel.add(schatzText);
        hauptPanel.add(kampfItems);
        hauptPanel.add(raumItems);
        hauptPanel.add(gesamtGewicht);
        hauptPanel.add(handwaffeWeglegen);
        hauptPanel.add(schutzwaffeWeglegen);
        hauptPanel.add(beenden);
        hauptPanel.add(aktivieren);
        hauptPanel.add(dalassen);
        raumItems.setLayout(null);
        raumItems.add(raumListeScroll);
        raumItems.add(raumText);
        raumItems.add(mitnehmen);
        kampfItems.setLayout(null);
        kampfItems.add(kampfMonster);
        kampfItems.add(weiterkämpfen);
        kampfItems.add(abbrechen);
        
    japadapadu.setText("J a p a d a p a d u");
    japadapadu.setLocation(100, 100);
    japadapadu.setVisible(true);
    japadapadu.setSize(200, 20);

    gefunden.setText("Der Ausgang ist gefunden");
    gefunden.setLocation(100, 130);
    gefunden.setVisible(true);
    gefunden.setSize(200, 20);
        
        okKnopf = new JButton("OK");
        okKnopf.setLocation(100, 160);
        okKnopf.setVisible(true);
        okKnopf.setSize(200, 30);
        okKnopf.setEnabled(true);
        okKnopf.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                kontroller.KommandoEintragen(Kommandos.spielAbbrechen, 0);
            }
        });

    endeMeldung.setLocation(0, 0);
    endeMeldung.setLayout(null);
    endeMeldung.setSize(800, 500);
    endeMeldung.add(japadapadu);
    endeMeldung.add(gefunden);
    endeMeldung.add(okKnopf);
        

        f = new JFrame("Landkarte");
        endeMeldung.setVisible(false);
        f.add(hauptPanel);
        f.add(endeMeldung);
        f.setSize(800, 600);
        f.setVisible(true);
    }
  
    /**
     * Setzt den Namen der Handwaffe
     * @param name Name der Handwaffe
     */
    public void HandwaffenNameSetzen(String name)
    {
        handwaffenText.setText("Handwaffe: " + name);
        handwaffeWeglegen.setEnabled(!name.equals("keine"));
    }

    /**
     * Setzt den Namen der Schutzwaffe
     * @param name Name der Schutzwaffe
     */
    public void SchutzwaffenNameSetzen(String name)
    {
        schutzwaffenText.setText("Schutzwaffe: " + name);
        schutzwaffeWeglegen.setEnabled(!name.equals("keine"));
    }

    /**
     * Setzt die Stärkenanzeige
     * @param st Wert der Stärke
     */
    public void StärkeSetzen(int st)
    {
        stärkeText.setText("Stärke: " + st);
    }

    /**
     * Fügt eine neue Botschaft an die Anzeige an.
     * @param text Botschaft
     */
    public void NeueBotschaftEintragen(String text)
    {
        infoText.setText(text + "\n" + infoText.getText());
    }

    /**
     * Trägt den Monsternamen ein und blendet die nötigen Anzeigen ein / aus.
     * @param text der Monstername
     */
    public void RundeVerlorenSetzen(String text)
    {
        raumItems.setVisible(false);
        mapping.setVisible(false);
        kampfItems.setVisible(true);
        kampfMonster.setText("Sie kämpfen mit Monster: " + text);
        dalassen.setEnabled(false);
    }

    /**
     * Beendet den Monsterkampf und blendet die nötigen Anzeigen ein / aus.
     */
    public void KampfZuEndeSetzen()
    {
        kampfItems.setVisible(false);
        mapping.setVisible(true);
        dalassen.setEnabled(true);
    }

    void RaumDatenAnzeigen()
    {
        raumItems.setVisible(true);
    }

    /**
     * Setzt die Anzahl der Schlüssel
     * @param anz Anzahl
     */
    public void SchlüsselAnzahlSetzen(int anz)
    {
        schlüsselAnzahl.setText("Schlüssel: " + anz);
    }
    
    /**
     * Setzt die Liste der Spielerschätze
     * @param texte Namen der Schätze
     */
    public void SpielerSchätzeSetzen(ArrayList<String> texte)
    {
        schatzListenModel.clear();
        schatzListenModel.addAll(texte);
    }
    
    /**
     * Setzt die Liste der Raumschätze
     * @param texte Namen der Schätze
     */
    public void RaumSchätzeSetzen(ArrayList<String> texte)
    {
        raumListenModel.clear();
        raumListenModel.addAll(texte);
        RaumDatenAnzeigen();
    }

    /**
     * Setzt das Gesamtgewicht der Schätze
     * @param gewicht Gesamtgewicht
     */
    public void GesamtgewichtSetzen(double gewicht)
    {
        gesamtGewicht.setText("Gesamtgewicht: " + gewicht);
    }

    /**
     * Löscht die Daten der Landkartenanzeige
     */
    public void LandkartendatenLöschen()
    {
        mapping.LandkartendatenLöschen();
    }
    
    /**
     * Trägt neue Rauminformation in die Landkartenanzeige ein.
     */
    public void RaumEintragen(LandkarteneintragRaum r)
    {
        mapping.RaumEintragen(r);
    }
    
    /**
     * Trägt neue Weginformation in die Landkartenanzeige ein.
     */
    public void WegEintragen(LandkarteneintragWeg w)
    {
        mapping.WegEintragen(w);
    }
    
    /**
     * Veranlasst das Neuzeichnen der Landkartenanzeige
     */
    public void LandkarteNeuZeichnen()
    {
        mapping.invalidate();
        mapping.repaint();
    }
    
    /**
     * Zeigt die Meldung über das erfolgreiche Spielende an.
     */
    public void EndemeldungAnzeigen()
    {
        hauptPanel.setVisible(false);
        endeMeldung.setVisible(true);
    }
}
