
/**
 * Der Bogen hat eine mittlere Angrifsstärke
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Bogen extends AngriffsWaffe
{

    /**
     * Der Konstruktor besetzt das Spiel
     * @param sp das Spiel, in dem das Objekt verwendet wird.
     */
    Bogen(Spiel sp)
    {
        super(sp);
        gewicht = 8.0;    
    }

    /**
     * Meldet die Stärke der Angriffskraft
     * @return Angriffsstärke
     */
    @Override int WaffenstärkeGeben()
    {
        return 10;
    }
    
    /**
     * Trägt ein, dass eine Waffe verwendet wurde.
     */
    void AnwendungEintragen()
    {
        super.AnwendungEintragen();
        if (anzahlAnwendungen >= 12)
        {
            spiel.spieler.schätze.remove(this);
            spiel.spieler.wo.SchatzVerstecken(this);
            spiel.spieler.InventarListeEintragen();
            anzahlAnwendungen = 0;
        }
    }
    
    /**
     * Meldet den Namen des Objekts zurück
     * @return name
     */
    @Override String NameGeben()
    {
        return "Bogen";
    }
}
