
/**
 * Das Monster Dieb.
 * Der Dieb klaut dem Spieler einen Schatz, wen dieser keine Handwaffe hat.
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Dieb extends Monster
{

    /**
     * Der Konstruktor besetzt das Spiel
     * @param sp das Spiel, in dem das Objekt verwendet wird.
     */
    Dieb(Spiel sp)
    {
        super(sp);
    }
    
    /**
     * Meldet den Namen des Objekts zurück
     * @return name
     */
    @Override String NameGeben()
    {
        return "Dieb";
    }
    
    /**
     * Einleitung des Kampfs.
     * Der Dieb meldet sich nur, wenn er klauen kann.
     * @param sp der angegriffene Spieler
     */
    @Override void KampfBeginnen(Spieler sp)
    {
        if ((!sp.schätze.isEmpty()) && (sp.handWaffe == null))
        {
            super.KampfBeginnen(sp);
        }
    }
    
    /**
     * Kampf des Spielers mit dem Monster
     * @param sp der angegriffene Spieler
     * @return wahr, wenn der Spieler den Kampf gewonnen hat.
     */
    @Override boolean KampfDurchführen(Spieler sp)
    {
        if ((!sp.schätze.isEmpty()) && (sp.handWaffe == null))
        {
            while ((!sp.schätze.isEmpty()) && (Zufall.zufall.GanzzahlGeben(2) == 0))
            {
                sp.wo.SchatzLagern (sp.schätze.remove(Zufall.zufall.GanzzahlGeben(sp.schätze.size())));
            }
            return false;
        }
        else
        {
            return true;
        }
    }
}
