
/**
 * Der Feuerball verjagt das Monster im Zielraum
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Feuerball extends Spruch
{

    /**
     * Der Konstruktor besetzt das Spiel
     * @param sp das Spiel, in dem das Objekt verwendet wird.
     */
    Feuerball(Spiel sp)
    {
        super(sp);
        gewicht = 3.0;
        mentalgewicht = 3;
    }

    /**
     * Meldet den Namen des Objekts zurück
     * @return name
     */
    @Override String NameGeben()
    {
        return "Feuerball";
    }
    
    /**
     * Führt den Spruch aus
     * @param vonwem der Spieler, der den Spruch ausführt
     */
    @Override void Ausführen()
    {
        spiel.spieler.schätze.remove(this);
        spiel.spieler.wo.monster = new LeeresMonster(spiel);
        spiel.spieler.wo.SchatzVerstecken(this);
        spiel.spieler.InventarListeEintragen();
    }
}
