
/**
 * Der Helm hat eine mittlere Abwekrstärke
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Helm extends SchutzWaffe
{

    /**
     * Der Konstruktor besetzt das Spiel
     * @param sp das Spiel, in dem das Objekt verwendet wird.
     */
    Helm(Spiel sp)
    {
        super(sp);
        gewicht = 15.0;    
    }

    /**
     * Meldet die Stärke der Abwehrkraft
     * @return Abwehrstärke
     */
    @Override int AbwehrstärkeGeben()
    {
        return 9 - anzahlAnwendungen / 2;
    }
    
    /**
     * Trägt ein, dass eine Waffe verwendet wurde.
     */
    @Override void AnwendungEintragen()
    {
        super.AnwendungEintragen();
        if (anzahlAnwendungen >= 18)
        {
            spiel.spieler.schätze.remove(this);
            spiel.spieler.wo.SchatzVerstecken(this);
            spiel.spieler.InventarListeEintragen();
            anzahlAnwendungen = 0;
        }
    }
    
    /**
     * Meldet den Namen des Objekts zurück
     * @return name
     */
    @Override String NameGeben()
    {
        return "Helm";
    }
}
