
/**
 * Oberklasse aller Monster
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Monster extends SpielObjekt
{
    
    /**
     * Der Konstruktor besetzt das Spiel
     * @param sp das Spiel, in dem das Objekt verwendet wird.
     */
    Monster(Spiel sp)
    {
        super(sp);
    }
    
    /**
     * Generiert ein zufälliges Monster
     * @param sp das Spiel, in dem das Objekt verwendet wird.
     * @return das erzeugt Monster
     */
    static Monster ZufälligGenerieren(Spiel spiel)
    {
        switch (Zufall.zufall.GanzzahlGeben(6))
        {
            case 0:
            case 1:
                return new Dieb(spiel);
            case 2:
            case 3:
                return new Schlange(spiel);
            case 4:
                return new Drache(spiel);
            case 5:
                return new Falltuer(spiel);
        }
        return new LeeresMonster(spiel);
    }
    
    /**
     * Kampf des Spielers mit dem Monster
     * @param sp der angegreifende Spieler
     * @return wahr, wenn der Spieler den Kampf gewonnen hat.
     */
    boolean KampfDurchführen(Spieler sp)
    {
        return true;
    }
    
    /**
     * Einleitung des Kampfs.
     * In der Regel die Meldung, welches Monster angreift.
     * @param sp der angegriffene Spieler
     */
    void KampfBeginnen(Spieler sp)
    {
        spiel.BotschaftSenden("Ein Monster fällt Sie an: " + NameGeben ());
    }
    
    /**
     * Kampfabbruch durch Flucht des Spielers.
     * Standardmäßig keine Aktion
     * @param sp der angegriffene Spieler
     */
    void KampfAbbrechen(Spieler sp)
    {
    }
}
