
/**
 * Oberklasse aller Schätze
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Schatz extends SpielObjekt
{
    /** Das Gewicht des Schatzes */
    protected double gewicht;

    /**
     * Der Konstruktor besetzt das Spiel
     * @param sp das Spiel, in dem das Objekt verwendet wird.
     */
    Schatz(Spiel sp)
    {
        super(sp);
        gewicht = 0.0;
    }

    /**
     * Generiert einen zufälligen Schatz
     * @param sp das Spiel, in dem das Objekt verwendet wird.
     * @return der erzeugte Schatz
     */
    static Schatz ZufälligGenerieren(Spiel spiel)
    {
        switch (Zufall.zufall.GanzzahlGeben(17))
        {
            case 0:
            case 1:
                return new Schwert(spiel);
            case 2:
            case 3:
            case 4:
                return new Dolch(spiel);
            case 5:
                return new Zweihaender(spiel);
            case 6:
                return new Ruestung(spiel);
            case 7:
            case 8:
                return new Helm(spiel);
            case 9:
            case 10:
            case 11:
                return new Lederkappe(spiel);
            case 12:
                return new Feuerball(spiel);
            case 13:
                return new RuckSack(spiel);
            case 14:
                return new Karte(spiel);
            case 15:
                return new Heiltrank(spiel);
            case 16:
                return new Bogen(spiel);
        }
        return null;
    }
    
    /**
     * Meldet das Gewicht des Schatzes
     * @return Gewicht
     */
    double GewichtGeben()
    {
        return gewicht;
    }
}
