
import java.util.*;
/**
 * Verwaltet die Türen eines Raums.
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Tueren
{
    /** Die erreichbaren Räume */
    protected ArrayList<Raum> türen;
    
    /**
     * Der Konstruktor legt das Fed der Türen an.
     */
    Tueren()
    {
        türen = new ArrayList<Raum>();
    }
    
    /**
     * Prüft, ob es eine Tür zum Raum mit der angegebenen Nummer gibt
     * @param nummer die Raumnummer
     * @return Raum oder null
     */
    Raum TürNachGeben(int nummer)
    {
        for (Raum r: türen)
        {
            if (r.nummer == nummer)
            {
                return r;
            }
        }
        return null;
    }

    /**
     * Meldet die Anzahl der Türen
     * @return Türenzahl
     */
    int AnzahlTürenGeben()
    {
        return türen.size();
    }
    
    /**
     * Meldet die Tür mit der angegebenen Nummer.
     * @param nummer die Türnummer
     * @return Raum
     */
    Raum TürNummerGeben(int nummer)
    {
        return türen.get(nummer);
    }
    
    /**
     * Trägt eine neue Tür in die Türliste ein
     * @param raum der Raum, zu dem die Tür führen soll
     */
    void NeueTürEintragen(Raum raum)
    {
        türen.add(raum);
    }
}
