
import java.util.Random;

/**
 * Der eine Zufallsgenerator
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Zufall
{
    /** Der Zufallsgenerator, nach der Testphase zufällig vorbesetzen */
    static final Zufall zufall = new Zufall();
    /** Der eigentliche Zufallsgenerator */
    private Random ran;
    
    /**
     * Privater Konstruktor
     */
    private Zufall()
    {
        //Nach der Testpahse ohne Parameter aufrufen
        ran = new Random(0);
    }

    /**
     * Gibt eine zufällige ganze Zahl zwischen 0 und obergrenze zurück
     * @param obergrenze OBergrenze für die Zufallszahlen
     * @return Zufallszahl
     */
    int GanzzahlGeben(int obergrenze)
    {
        return ran.nextInt(obergrenze);
    }
}
