
/**
 * Beschreibt einen Bewegungsmelder
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Bewegungsmelder extends Messgeraet
{
    /** aktueller Wert der Messung */
    private boolean an;
    
    /**
     * Legt den Namen und den Beobachter fest.
     * @param namensZusatz individualler Namensteil des Sensors
     */
    Bewegungsmelder(String namensZusatz)
    {
        super("Bewegungsmelder " + namensZusatz);
        an = false;
    }
    
    /**
     * Setzt den neuen Sensorwert
     * @param an der neue Sensorwert
     */
    @Override void WertSetzen (boolean an)
    {
        this.an = an;
        MesswertÄnderungMelden(an);
    }
    
    /**
     * Meldet den Zustand des Sensors
     * @return Zustand als Zeichenkette
     */
    @Override String ZustandGeben()
    {
        return an ? "Bewegung" : "Ruhe";
    }
}
