
/**
 * Beschreibt den allgemeinen Teil einer Hauskomponente
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Hausgeraet extends Smartkomponente
{
    /** Automatikbetrieb */
    protected boolean automatik;
    
    /**
     * Schaltet die Automatik ein
     * @param name der Komponentenname
     */
    Hausgeraet(String name)
    {
        super(name);
        automatik = true;
    }
    
    /**
     * Wird von einem Messgerät bei einem neuen Wert aufgerufen
     * @param wert der neue Wert
     * @param wer das aufrufende Messgerät
     */
    void WertänderungMelden(int wert, Messgeraet wer)
    {
    }
    
    /**
     * Wird von einem Messgerät bei einem neuen Wert aufgerufen
     * @param wert der neue Wert
     * @param wer das aufrufende Messgerät
     */
    void WertänderungMelden(boolean wert, Messgeraet wer)
    {
    }
    
    /**
     * Schaltet die Komponente dauerhaft ein
     * Muss überschrieben werden
     */
    void Einschalten()
    {
        automatik = false;
    }
    
    /**
     * Schaltet die Komponente dauerhaft aus
     * Muss überschrieben werden
     */
    void Ausschalten()
    {
        automatik = false;
    }
    
    /**
     * Schaltet die Komponente auf Automatikbetrieb
     * Muss überschrieben werden
     */
    void AutomatikAktivieren()
    {
        automatik = true;
    }
}
