
import java.util.ArrayList;
/**
 * Beschreibt die allgemeinen Teile eines Messgeräts
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Messgeraet extends Smartkomponente
{
    /** Messwertbeobachter dieses Messgeräts */
    private ArrayList<Hausgeraet> beobachter;
    
    /**
     * Richtet das Beobachterfeld ein
     * @param name der Gerätename
     */
    Messgeraet(String name)
    {
        super(name);
        beobachter = new ArrayList<Hausgeraet>();
    }

    /**
     * Registriert einen Beobachter
     * @param beobachter wird von jeder Wertänderung benachrichtigt
     */
    void BeobachterRegistrieren (Hausgeraet neuerBeobachter)
    {
        beobachter.add(neuerBeobachter);
    }
    
    /**
     * Meldet den neuen Wert an alle Beobachter
     * @wert der zu meldende Wert
     */
    protected void MesswertÄnderungMelden(int wert)
    {
        for (Hausgeraet k: beobachter)
        {
            k.WertänderungMelden(wert, this);
        }
    }
    
    /**
     * Meldet den neuen Wert an alle Beobachter
     * @param wert der zu meldende Wert
     */
    protected void MesswertÄnderungMelden(boolean wert)
    {
        for (Hausgeraet k: beobachter)
        {
            k.WertänderungMelden(wert, this);
        }
    }
    
    /**
     * Setzt den neuen Sensorwert
     * @param eingabe der neue Sensorwert
     */
    void WertSetzen (int eingabe)
    {
    }
    
    /**
     * Setzt den neuen Sensorwert
     * @param eingabe der neue Sensorwert
     */
    void WertSetzen (boolean eingabe)
    {
    }
}
