
/**
 * Beschreibt einen Lichtsensor
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Sonnensensor extends Messgeraet
{
    /** aktueller Wert der Messung */
    private int aktuellerWert;

    /**
     * Legt den Namen und den Beobachter fest.
     * @param namensZusatz individualler Namensteil des Sensors
     */
    Sonnensensor(String namensZusatz)
    {
        super("Sonnensensor " + namensZusatz);
        aktuellerWert = 0;
    }

    /**
     * Setzt den neuen Sensorwert
     * @param eingabe der neue Sensorwert
     */
    @Override void WertSetzen (int eingabe)
    {
        if ((eingabe >= 0) && (eingabe <= 100))
        {
            aktuellerWert = eingabe;
            MesswertÄnderungMelden(aktuellerWert);
        }
    }
    
    /**
     * Meldet den Zustand des Sensors
     * @return Zustand als Zeichenkette
     */
    @Override String ZustandGeben()
    {
        return "" + aktuellerWert + " %";
    }
}
