
/**
 * Beschreibt ein Thermometer
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Thermometer extends Messgeraet
{
    /** aktueller Wert der Messung */
    private int aktuellerWert;

    /**
     * Legt den Namen und den Beobachter fest.
     * @param namensZusatz individualler Namensteil des Sensors
     */
    Thermometer(String namensZusatz)
    {
        super("Thermometer " + namensZusatz);
        aktuellerWert = 0;
    }
    
    /**
     * Setzt den neuen Sensorwert
     * @param eingabe der neue Sensorwert
     */
    @Override void WertSetzen (int eingabe)
    {
        if ((eingabe >= -50) && (eingabe <= 100))
        {
            aktuellerWert = eingabe;
            MesswertÄnderungMelden(aktuellerWert);
        }
    }
    
    /**
     * Meldet den Zustand des Sensors
     * @return Zustand als Zeichenkette
     */
    @Override String ZustandGeben()
    {
        return "" + aktuellerWert + " ˚C";
    }
}
