
import java.util.ArrayList;
/**
 * Beschreibt eine Waage
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Waage
{
    /** Name des Sensors */
    private String name;
    /** aktueller Wert der Messung */
    private int aktuellerWert;
    /** Kühlschränke, denen Änderungen gemeldet werden */
    private ArrayList<Kuehlschrank> beobachter;
    
    /**
     * Legt den Namen und den Beobachter fest.
     * @param namensZusatz individualler Namensteil des Sensors
     */
    Waage(String namensZusatz)
    {
        name = "Waage " + namensZusatz;
        beobachter = new ArrayList<Kuehlschrank>();
        aktuellerWert = 0;
    }
    
    /**
     * Meldet den Namen des Geräts zurück
     * @return Name
     */
    String NameGeben()
    {
        return name;
    }
    
    /**
     * Registriert einen Beobachter
     * @param beobachter wird von jeder Wertänderung benachrichtigt
     */
    void BeobachterRegistrieren (Kuehlschrank beobachter)
    {
        this.beobachter.add(beobachter);
    }

    /**
     * Setzt den neuen Sensorwert
     * @param eingabe der neue Sensorwert
     */
    void WertSetzen (int eingabe)
    {
        if ((eingabe >= 0) && (eingabe <= 10000))
        {
            aktuellerWert = eingabe;
            for (Kuehlschrank b: beobachter)
            {
                b.WertänderungMelden(aktuellerWert);
            }
        }
    }
    
    /**
     * Meldet den Zustand des Sensors
     * @return Zustand als Zeichenkette
     */
    String ZustandGeben()
    {
        return "" + aktuellerWert + " g";
    }
}
