
import java.util.ArrayList;
/**
 * Beschreibt einen Windsensor
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Windsensor
{
    /** Name des Sensors */
    private String name;
    /** aktueller Wert der Messung */
    private int aktuellerWert;
    /** Rolläden, denen Änderungen gemeldet werden */
    private ArrayList<Rollladen> beobachter;
    
    /**
     * Legt den Namen und den Beobachter fest.
     * @param namensZusatz individualler Namensteil des Sensors
     */
    Windsensor(String namensZusatz)
    {
        name = "Windsensor " + namensZusatz;
        beobachter = new ArrayList<Rollladen>();
        aktuellerWert = 0;
    }
    
    /**
     * Meldet den Namen des Geräts zurück
     * @return Name
     */
    String NameGeben()
    {
        return name;
    }
    
    /**
     * Registriert einen Beobachter
     * @param beobachter wird von jeder Wertänderung benachrichtigt
     */
    void BeobachterRegistrieren (Rollladen beobachter)
    {
        this.beobachter.add(beobachter);
    }

    /**
     * Setzt den neuen Sensorwert
     * @param eingabe der neue Sensorwert
     */
    void WertSetzen (int eingabe)
    {
        if ((eingabe >= 0) && (eingabe <= 12))
        {
            aktuellerWert = eingabe;
            for (Rollladen b: beobachter)
            {
                b.WertänderungMeldenWindSensor(aktuellerWert);
            }
        }
    }
    
    /**
     * Meldet den Zustand des Sensors
     * @return Zustand als Zeichenkette
     */
    String ZustandGeben()
    {
        return "" + aktuellerWert + " Bft";
    }
}
