import java.util.ArrayList;
import java.util.Random;

/**
 * Jump 'n' Run-Spiel mit dem Protagonisten Dorian
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
public class Dorianland extends Ereignisbehandlung
{
    private Dorian dorian;

    /**
     * Legt das Szenario und die Spielfigur an
     * @param levelNr das gewünschte Spiellevel
     */
    public Dorianland(int levelNr)
    {        
        super();
        dorian = new Dorian();
        Text text = new Text();
        text.TextSetzen("← →: Gehen     Leertaste: Springen");
        text.PositionSetzen(300, 500);
        LevelSetzen(levelNr);       
        TaktdauerSetzen(10);
        Starten();
    }

    /**
     * Setzt das gewünschte Level.
     * @param levelNr das gewünschte Spiellevel
     */
    private void LevelSetzen(int levelNr)
    {
        switch (levelNr)
        {
            case 1:
            Level1();
            break;            

            case 2:
            Level2();
            break;

            case 3:
            Level3();
            break;

            default:
            System.out.println("Ein Level mit dieser Nummer existiert nicht!");
        }
    }

    /**
     * Erstellt die Welt für Level 1.
     */
    private void Level1()
    {
        // Weg
        Stahltraeger weg;
        weg = new Stahltraeger(800);
        weg.PositionSetzen(0, 400);

        // Kisten und Untier
        Kiste k1;
        k1 = new Kiste();
        k1.PositionSetzen(250, 350);
        Kiste k2;
        k2 = new Kiste();
        k2.PositionSetzen(450, 350);
        Gleiter u1;
        u1 = new Gleiter();
        u1.PositionSetzen(375, 375);

        // Ziel
        Ziel ziel;
        ziel = new Ziel();
        ziel.PositionSetzen(735, 250);

        Stahltraeger st;
        st = new Stahltraeger();
        st.PositionSetzen(275, 325);

        Kiste k3;
        k3 = new Kiste();
        k3.PositionSetzen(635, 350);

        Kiste k4;
        k4 = new Kiste();
        k4.PositionSetzen(685, 350);

        Kiste k5;
        k5 = new Kiste();
        k5.PositionSetzen(685, 300);
    }   
    
    /**
     * Erstellt die Welt für Level 2.
     */
    private void Level2()
    {
        // Weg oben
        Stahltraeger oben = new Stahltraeger(100);
        oben.PositionSetzen(0, 150);
      
        // Weg unten
        Stahltraeger unten = new Stahltraeger(800);
        unten.PositionSetzen(100, 400);

        // Ziel
        Ziel ziel;
        ziel = new Ziel();
        ziel.PositionSetzen(735, 275);

        // Treppe1 bauen
        ArrayList<Stufe> treppe1; 
        treppe1 = new ArrayList();

        for (int index = 0; index < 10; index = index + 1)
        {
            // Stufe erstellen und dem Feld hinzufügen
            treppe1.add(new Stufe(10 - index));
            // Stufe positionieren
            treppe1.get(index).XPositionSetzen(100 + index * 25);
        }

        // Treppe2 bauen
        ArrayList<Stufe> treppe2;
        treppe2 = new ArrayList();

        for (int index = 0; index < 5; index = index + 1)
        {
            treppe2.add(new Stufe(index + 1));
            treppe2.get(index).XPositionSetzen(610 + index * 25);
        }

    }

    /**
     * Erstellt die Welt für Level 3.
     */
    private void Level3()
    {
        Stahltraeger boden;
        boden = new Stahltraeger(800);
        boden.PositionSetzen(0, 400);

        Kiste kRechts;
        kRechts = new Kiste();
        kRechts.PositionSetzen(800, 350);

        Kiste k;
        for (int zähler = 0; zähler < 3; zähler = zähler + 1)
        {
            k = new Kiste();
            k.PositionSetzen(50 - (zähler % 2) * 10, 350 - zähler * 50);
            if (zähler < 2)
            {
                k = new Kiste();
                k.PositionSetzen(160 - (zähler % 2) * 10, 350 - zähler * 50);
            }
        }

        Stahltraeger s;
        s = new Stahltraeger(100);
        s.PositionSetzen(50, 225);

        Gleiter g;
        g = new Gleiter();
        g.PositionSetzen(125, 350);

        // Ziel
        Ziel ziel;
        ziel = new Ziel();
        ziel.PositionSetzen(735, 400);
        
        /*
         * Hier müssen noch Untiere ergänzt werden.
         */
        
    }

    /**
     * Mitverantwortlich für die Steuerung von Dorian
     */
    @Override void TaktImpulsAusführen()
    {
        if (dorian.Berührt("grün"))
        {
            Anhalten();
            dorian.Stoppen();
        }
        else if (dorian.Berührt("cyan"))
        {
            Anhalten();
            dorian.Stoppen();
        }
    }
}
