
/**
 * Gefährliches springendes Untier im Dorianland
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
public class Springer extends Figur
{
    private boolean sprung;
    private int sprungzähler;
    private int teilsprungzähler;

    /**
     * Standardkonstruktor
     */
    public Springer()
    {
        super();
        FigurFestlegen();
        sprung = false;
        sprungzähler = 0;
        teilsprungzähler = 0;
    }

    /**
     * Steuert das Springen und Fallen des Springers.
     */
    @Override void AktionAusführen()
    {        
        // wenn er den Boden berührt --> nach oben abspringen
        if (Berührt("grau"))
        {
            sprungzähler = 20;
            sprung = true;
            Teilsprung();
        }

        // wenn er den Boden nicht berührt und noch in der Sprungbewegung nach oben ist
        if (!Berührt("grau") && sprungzähler > 0)
        {
            Teilsprung();
        }

        // Fallen
        if (!(Berührt("grau")) && YPositionGeben() < 600 && sprungzähler == 0)
        {
            // Fallen nach dem Absprung
            if (sprung)
            {
                PositionSetzen(XPositionGeben(), YPositionGeben() + 1);
                if (!Berührt("grau") && YPositionGeben() < 600)
                {
                    PositionSetzen(XPositionGeben(), YPositionGeben() + 1);
                }

            }
            // Fallen ohne vorangegangenen Absprung
            else
            {
                while (!Berührt("grau") && YPositionGeben() < 600 && sprungzähler == 0)
                {
                    PositionSetzen(XPositionGeben(), YPositionGeben() + 1);
                }
            }

            if (Berührt("grau"))
            {
                sprung = false;
            }
        }
    }

    /**
     * Für die Steuerung beim Springen mitverantwortlich.
     */
    private void Teilsprung()
    {
        if (teilsprungzähler <= 0)
        {
            PositionSetzen(XPositionGeben(), YPositionGeben() - 10);
            sprungzähler = sprungzähler - 1;
            teilsprungzähler = 5;
        }
        else
        {
            teilsprungzähler = teilsprungzähler - 1;
        }
    }

    /**
     * Legt das Aussehen des Springers fest.
     */
    private void FigurFestlegen()
    {
        FigurteilFestlegenEllipse(-10, -50, 20, 20, "grün");
        FigurteilFestlegenEllipse(-20, -30, 40, 40, "grün");
        FigurteilFestlegenEllipse(-30, 10, 60, 60, "grün");
        FigurteilFestlegenEllipse(-15, -30, 10, 10, "rot");
        FigurteilFestlegenEllipse(5, -30, 10, 10, "rot");
        FigurteilFestlegenDreieck(-20, -35, -10, -30, -5, -35, "rot");
        FigurteilFestlegenDreieck(20, -35, 10, -30, 5, -35, "rot");
        FigurteilFestlegenRechteck(-20, -15, 40, 5, "rot");
    }
}